<link rel="import" href="../../bower_components/polymer/polymer-element.html">

<link rel="import" href="../../bower_components/neon-animation/animations/scale-up-animation.html">
<link rel="import" href="../../bower_components/paper-button/paper-button.html">
<link rel="import" href="../../bower_components/iron-icons/communication-icons.html">

<dom-module id="dez-profile-menu">
  <template>
    <style>
      #menu {
        position : fixed;
        width : 200px;
        top : 50px;
        right : -30px;
      }
      paper-button {
        max-width : none;
        text-transform: none;
      }
    </style>

    <template is="dom-if" if="[[visible]]">
      <paper-icon-button
        icon="communication:vpn-key"
        title="Profile"
        on-tap="_openProfileMenu">
      </paper-icon-button>
    </template>
    <paper-dialog id="menu" entry-animation="fade-in-animation" exit-animation="fade-out-animation">
      <h3>{{_user.name}}</h3>
      <paper-button id="changePwdLink" dialog-confirm on-tap="_openChangePwdDialog">Change password</paper-button>
      <paper-button id="logOutLink" dialog-confirm autofocus on-tap="_logout">Log out</paper-button>
    </paper-dialog>

    <paper-dialog id="ChangePwdDialog" entry-animation="scale-up-animation" with-backdrop>
      <h2>Change your password</h2>
      <template is="dom-if" if="[[error]]">
        <p class="alert-error"><strong>Error:</strong> [[error]]</p>
      </template>
      <paper-input label="Old Password" type="password" value="{{formData.oldpassword}}"></paper-input>
      <paper-input label="New Password" type="password" value="{{formData.newpassword}}"></paper-input>
      <paper-input label="Verify" type="password" value="{{formData.newpassword2}}"></paper-input>
      <div class="wrapper-btns">
        <paper-button raised class="primary" on-tap="_postNewPassword">Change password</paper-button>
      </div>
    </paper-dialog>

    <iron-ajax
        id="changepwAjax"
        method="post"
        content-type="application/json"
        handle-as="text"
        on-response="_handleUserResponse"
        on-error="_handleUserError">
    </iron-ajax>

  </template>

  <script>

  class DezProfileMenu extends Polymer.Element {

      static get is() { return 'dez-profile-menu'; }

      static get properties() {
        return {
          formData: {
            type: Object,
            value: {}
          },
          error: String,
          authServer: String,
          visible : Boolean
        }
      }

      set user (value) {
        this._user = value
      }

      _openProfileMenu () {
        this.$.menu.open();
      }

      _logout () {
        this._user = null
        this.dispatchEvent(new CustomEvent("user-logged-out"))
      }

      _openChangePwdDialog () {
        this.$.ChangePwdDialog.open();
      }

      _postNewPassword() {
        if (this.formData.newpassword == this.formData.newpassword2) {
          this.$.changepwAjax.url = this.authServer + "/changepw";
          this.formData.uid = this._user.name
          this.$.changepwAjax.body = this.formData;
          this.$.changepwAjax.generateRequest();
          this.$.ChangePwdDialog.close()
        } else {
          this.error = "new password inputs do not match"
        }
      }

      _handleUserResponse(event) {
        let response = JSON.parse(event.detail.response);
        if (response.access_token) {
          this.error = '';
          this._user = {
            name: this.formData.uid,
            access_token: response.access_token,
            loggedin: true
          };
          this.dispatchEvent(new CustomEvent("user-changed-password", {
            detail : this._user
          }))
        }
        // reset form data
        this.formData = {};
      }

      _handleUserError(event) {
        this.error = event.detail.request.xhr.response;
        this._openChangePwdDialog()
      }

  }

  window.customElements.define(DezProfileMenu.is, DezProfileMenu);

  </script>
</dom-module>
